#ifndef MAINWINDOW_H
#define MAINWINDOW_H

#include <QMainWindow>
#include <QProcess>
#include <QMap>
#include <QFile>

#ifdef Q_OS_UNIX
#include <QSocketNotifier>
#endif

namespace Ui {
    class MyBookReader;
}

class MainWindow : public QMainWindow
{
    Q_OBJECT

    int pX, pY;

    QList<QString> m_bookList;
    QFile m_bookListFile;

    QString m_argList;
    QMap <QString,QString> m_sets;          // параметры командной строки (параметр - значение параметра)
    QMap <QString,QString> m_apps;          // приложения (расширение - приложение)

    enum { NAME, AUTHOR, DATEOFCREATION, FILENAME };

    QProcess *process;

    int timerChkExitId;

    void closeEvent(QCloseEvent*);

    void mousePressEvent(QMouseEvent*);
    void mouseReleaseEvent(QMouseEvent*);
    void mouseMoveEvent(QMouseEvent*);

    void timerEvent(QTimerEvent*);
    bool eventFilter(QObject*, QEvent*);
    void quitReader();

public:
    MainWindow(const QString &args, QWidget *parent = 0);
    ~MainWindow();

#ifdef Q_OS_UNIX
    static void termSignalHandler(int unused);
#endif

public slots:
//#ifdef Q_OS_UNIX
    void handleSigTerm();
//#endif

private:
    Ui::MyBookReader *ui;    

#ifdef Q_OS_UNIX
    static int sigtermFd[2];
    QSocketNotifier *snTerm;
#endif

private slots:
    void pressOpenButton();
    void pressCloseButton();
    void pressQuitButton();

};

#endif // MAINWINDOW_H
