#ifndef ARRANGEMENT_H
#define ARRANGEMENT_H

#include "ui_arrangementdialog.h"
#include "anybox.h"
#include "mysrcfolder.h"
#include "mysssfile.h"
#include "mylogfile.h"

#include <QFrame>

/*
  Размещение (widget)
  Переносит файлы из каталога-источника в MyBox. Новые, для MyBox, файлы, удаляются из каталога-источника,
  Уже существующие в MyBox файлы остаются в каталоге-источнике. Выполненые действия регистрируются в
  log-файле.
*/

class Arrangement: public QFrame, public Ui::ArrangementDialogGUI
{
    Q_OBJECT

    AnyBox *m_box;

    MySrcFolder* src;       // каталог исходных файлов
    MySssFile* sss;         // файл регистрации сессий
    MyLogFile* log;         // файл - журнал

                            // доступные имена файлов, каталогов и подкаталогов в MyBox
                            // (используется две латинских буквы)
    QStringList abcNames;   // список 'aa','ab',...,'az','ba','bb',...,'bz',...,'za','zb',...,'zz'
    int capacity;           // количество элементов abcNames (676 элементов)

    QString currentSession; // номер новой сессии
    bool m_useAutoFill;

    QStringList abcSubtract(QStringList);   // возвращает список-разницу между списками abcNames и заданным
    QStringList abcSubtract(QObjectList);   //
    QString abcRnd(QStringList);            // возвращает случайный элемент из списка

    bool eventFilter(QObject *, QEvent *);
    void changeEvent(QEvent *);    

private slots:
    void pressStartButton();

public:
    Arrangement(AnyBox*, QFrame*);

signals:
    void needUpdateStatus();
};

#endif // ARRANGEMENT_H
