#include "basefolder.h"
#include <QDir>

BaseFolder::BaseFolder(const QString &initPath, const QString &name) : MyFolder(name)
{
    QString s;
    s = initPath.trimmed();
    m_path = s;
    if (!s.endsWith(QDir::separator())) {
        m_path.append(QDir::separator());
    }
    m_initOk = create();
}

void BaseFolder::setFirstDir(const QString &dir)
{
    m_firstDir = dir;
}

QString BaseFolder::firstDir()
{
    return m_firstDir;
}

void BaseFolder::setBackupDir(const QString &dir)
{
    m_cpyDir = dir;
}

QString BaseFolder::backupDir()
{
    return m_cpyDir;
}

void BaseFolder::setBurnCDApp(const QString &app)
{
    m_burnCDApp = app;
}

QString BaseFolder::burnCDApp()
{
    return m_burnCDApp;
}

void BaseFolder::setExtractApp(const QString &app)
{
    m_extractApp = app;
}

QString BaseFolder::extractApp()
{
    return m_extractApp;
}

QList<AnyBox*> BaseFolder::boxes()
{
    return m_boxes;
}

AnyBox* BaseFolder::addBox(const QString name)
{
    AnyBox *newBox;
    newBox = new AnyBox(name, this);
    m_boxes << newBox;
    return newBox;
}
