#ifndef BASEFOLDER_H
#define BASEFOLDER_H

#include "myfolder.h"
#include "anybox.h"

#include <QList>

/*
  Основной каталог (основной элемент)
  Основан на MyFolder
  При создании указывается путь и имя каталога (элемента)
  Является основой MyBox. Содержит список всех anybox и сведений об их общих параметрах:
    m_firstDir   - каталоги для поиска исходных файлов
    m_cpyDir     - каталог для резервного копирования
    m_burnCDApp  - приложение для записи на CD
    m_extractApp - приложение для извлечения даты и времени из exif исходного файла
  Метод addBox(...) создает anybox и добавляет его в список boxes
*/

class BaseFolder : public MyFolder
{        
    QString m_firstDir;
    QString m_cpyDir;
    QString m_burnCDApp;
    QString m_extractApp;
    QList<AnyBox*> m_boxes;

public:
    BaseFolder(const QString &initPath, const QString &name);
    void setFirstDir(const QString &);
    QString firstDir();
    void setBackupDir(const QString &);
    QString backupDir();
    void setBurnCDApp(const QString &);
    QString burnCDApp();
    void setExtractApp(const QString &);
    QString extractApp();

    QList<AnyBox*> boxes();
    AnyBox* addBox(const QString name);
};

#endif // BASEFOLDER_H
