#include "bookbox.h"
#include "remark.h"
#include "global.h"

#include <QTextStream>
#include <QDir>

BookBox::BookBox(const QString &name, MyUnit* parent) : AnyBox(name, parent)
{
    m_dateFormat = "yyyy";
    m_useSubFile = true;
}

void BookBox::setCategoryLabels()
{
    Category cat;

    cat.setSubCategories_A("A", "A,B,C,D,E,F,G,H,I", false, false);
    cat.setSubCategories_C(tr("Home country"), tr("native,foreign"), true, false);
    cat.setSubCategories_D(tr("Time range"), tr("other,antique,classic,modern"), true, false);
    cat.setSubCategories_E(tr("Auditory"), tr("all,baby,youth,grownup"), true, false);

    QString myCat = m_myCategories;

    myCat.replace("blank", tr("blank"));
    myCat.replace("belles", tr("belles"));
    myCat.replace("information", tr("information"));
    myCat.replace("popular_science", tr("popular_science"));
    myCat.replace("periodical", tr("periodical"));
    myCat.replace("educational", tr("educational"));
    myCat.replace("technical", tr("technical"));
    myCat.replace("folklore", tr("folklore"));
    myCat.replace("fantasy", tr("fantasy"));
    myCat.replace("detective", tr("detective"));
    myCat.replace("adventure", tr("adventure"));
    myCat.replace("creation", tr("creation"));
    myCat.replace("art", tr("art"));
    myCat.replace("empty_A", tr("empty_A"));
    myCat.replace("empty_B", tr("empty_B"));
    myCat.replace("empty_C", tr("empty_C"));
    cat.setSubCategories_F(tr("Genre"), myCat, true, true);

    cat.setSubCategories_G(tr("Style"), tr("prose,poesy"), true,false);

    m_category = cat;
}

quint32 BookBox::startValueCategory(MySourceFile *file)
{
    quint32 result = 0;

    return result;

}

void BookBox::makeSubFile(QString s)
{

    QStringList l;
    l = s.split("\n");

    Remark r(l.takeFirst());

    QStringList m;
    QStringList titleAndAuthor;
    if (!l.isEmpty()) {
        titleAndAuthor = l.takeFirst().split(",");

        switch(titleAndAuthor.count()){
        case 1:
            m << titleAndAuthor.at(0);
            m << "";
            break;
        case 2:
            m << titleAndAuthor.at(0);
            m << titleAndAuthor.at(1);
            break;
        default:
            m << "" << "";
        }
    }

    if (!l.isEmpty()) {
        m << l.takeFirst();
    }

    QString subFilename;
    subFilename = completeName() + QDir::separator() + r.re() + QDir::separator() + r.ma() +
                  QDir::separator() + r.rk() + "." + SUB_FILE_EXT;

    QFile f(subFilename);

    QTextStream st(&f);
    st.setCodec("UTF-8");
    st.setGenerateByteOrderMark(false);

    if (initOk()) {
        if (f.open(QIODevice::WriteOnly | QIODevice::Text)) {
            st << m.join("\n") << endl;
            f.close();
        }
    }
}

