#include "category.h"

Category::Category()
{     
    m_A.title = QObject::tr("Which");   
    m_A.contents << content(QObject::tr("water"), QObject::tr(""));
    m_A.contents << content(QObject::tr("sky"),   QObject::tr(""));
    m_A.contents << content(QObject::tr("land"),  QObject::tr(""));
    m_A.contents << content(QObject::tr("flora"), QObject::tr(""));
    m_A.contents << content(QObject::tr("fauna"), QObject::tr(""));
    m_A.contents << content(QObject::tr("humans"),QObject::tr(""));
    m_A.contents << content(QObject::tr("build"), QObject::tr(""));
    m_A.contents << content(QObject::tr("wheel"), QObject::tr(""));
    m_A.contents << content(QObject::tr("item"),  QObject::tr(""));
    m_A.use = true;
    m_A.testable = true;

    m_B.title = QObject::tr("WhichMain"); 
    m_B.contents << content(QObject::tr("Water"), QObject::tr(""));
    m_B.contents << content(QObject::tr("Sky"),   QObject::tr(""));
    m_B.contents << content(QObject::tr("Land"),  QObject::tr(""));
    m_B.contents << content(QObject::tr("Flora"), QObject::tr(""));
    m_B.contents << content(QObject::tr("Fauna"), QObject::tr(""));
    m_B.contents << content(QObject::tr("Humans"),QObject::tr(""));
    m_B.contents << content(QObject::tr("Build"), QObject::tr(""));
    m_B.contents << content(QObject::tr("Wheel"), QObject::tr(""));
    m_B.contents << content(QObject::tr("Item"),  QObject::tr(""));
    m_B.use = true;
    m_B.testable = false;

    m_C.title = QObject::tr("Where");
    m_C.contents << content(QObject::tr("inside"), QObject::tr(""));
    m_C.contents << content(QObject::tr("outside"),QObject::tr(""));
    m_C.use = true;
    m_C.testable = false;

    m_D.title = QObject::tr("Daytime"); 
    m_D.contents << content(QObject::tr("night"),   QObject::tr(""));
    m_D.contents << content(QObject::tr("morning"), QObject::tr(""));
    m_D.contents << content(QObject::tr("day"),     QObject::tr(""));
    m_D.contents << content(QObject::tr("evening"), QObject::tr(""));
    m_D.use = true;
    m_D.testable = false;

    m_E.title = QObject::tr("Season");
    m_E.contents << content(QObject::tr("winter"), QObject::tr(""));
    m_E.contents << content(QObject::tr("spring"), QObject::tr(""));
    m_E.contents << content(QObject::tr("summer"), QObject::tr(""));
    m_E.contents << content(QObject::tr("autumn"), QObject::tr(""));
    m_E.use = true;
    m_E.testable = false;

    m_F.title = QObject::tr("Picture");
    m_F.contents << content(QObject::tr("chronicle"),  QObject::tr(""));
    m_F.contents << content(QObject::tr("informative"),QObject::tr(""));
    m_F.contents << content(QObject::tr("event"),      QObject::tr(""));
    m_F.contents << content(QObject::tr("situation"),  QObject::tr(""));
    m_F.contents << content(QObject::tr("moment"),     QObject::tr(""));
    m_F.contents << content(QObject::tr("detail"),     QObject::tr(""));
    m_F.contents << content(QObject::tr("pictorial"),  QObject::tr(""));
    m_F.contents << content(QObject::tr("composition"),QObject::tr(""));
    m_F.contents << content(QObject::tr("series"),     QObject::tr(""));
    m_F.contents << content(QObject::tr("essay"),      QObject::tr(""));
    m_F.contents << content(QObject::tr("empty_A"),    QObject::tr(""));
    m_F.contents << content(QObject::tr("empty_B"),    QObject::tr(""));
    m_F.contents << content(QObject::tr("empty_C"),    QObject::tr(""));
    m_F.contents << content(QObject::tr("empty_D"),    QObject::tr(""));
    m_F.contents << content(QObject::tr("empty_E"),    QObject::tr(""));
    m_F.contents << content(QObject::tr("empty_F"),    QObject::tr(""));
    m_F.use = true;
    m_F.testable = false;

    m_G.title = QObject::tr("Method");    
    m_G.contents << content(QObject::tr("pose"),     QObject::tr(""));
    m_G.contents << content(QObject::tr("reporting"),QObject::tr(""));
    m_G.use = true;
    m_G.testable = false;
}

quint32 Category::subCategoryValue_A(quint32 c)
{
    return c & 511;
}

quint32 Category::subCategoryValue_B(quint32 c)
{
    quint32 a;
    a = c & 511;
    return (c >> 9 & 511) & a;
}

quint32 Category::subCategoryValue_C(quint32 c)
{
    return c >> 18 & 1;
}

quint32 Category::subCategoryValue_D(quint32 c)
{
    return c >> 19 & 3;
}

quint32 Category::subCategoryValue_E(quint32 c)
{
    return c >> 21 & 3;
}

quint32 Category::subCategoryValue_F(quint32 c)
{
    return c >> 23 & 15;
}

quint32 Category::subCategoryValue_G(quint32 c)
{
    return c >> 27 & 1;
}

void Category::setSubCategories_A(const QString & title, const QString & cont, bool use, bool testable)
{
    m_A.title = title;
    m_A.contents.clear();
    m_B.contents.clear();

    foreach(QString n, cont.split(",")){
        QString nm;
        QString ds;
        QStringList l;
        l = n.split("|");
        switch(l.count()){
        case 2:
            ds = l.value(1).simplified();
        case 1:
            nm = l.value(0).simplified();
        default:;
        }

        m_A.contents << content(nm, ds);

        QString c;
        c = nm.left(1).toUpper();
        m_B.contents << content(nm.replace(0,1,c),"");
    }
    m_A.use = use;
    m_A.testable = testable;
    m_B.testable = false;
}

void Category::setSubCategories_C(const QString & title, const QString & cont, bool use, bool testable)
{
    m_C.title = title;
    m_C.contents.clear();
    foreach(QString n, cont.split(",")){
        QString nm;
        QString ds;
        QStringList l;
        l = n.split("|");
        switch(l.count()){
        case 2:
            ds = l.value(1).simplified();
        case 1:
            nm = l.value(0).simplified();
        default:;
        }
        m_C.contents << content(nm, ds);
    }
    m_C.use = use;
    m_C.testable = testable;
}

void Category::setSubCategories_D(const QString & title, const QString & cont, bool use, bool testable)
{
    m_D.title = title;
    m_D.contents.clear();
    foreach(QString n, cont.split(",")){
        QString nm;
        QString ds;
        QStringList l;
        l = n.split("|");
        switch(l.count()){
        case 2:
            ds = l.value(1).simplified();
        case 1:
            nm = l.value(0).simplified();
        default:;
        }
        m_D.contents << content(nm, ds);
    }
    m_D.use = use;
    m_D.testable = testable;
}

void Category::setSubCategories_E(const QString & title, const QString & cont, bool use, bool testable)
{
    m_E.title = title;
    m_E.contents.clear();
    foreach(QString n, cont.split(",")){
        QString nm;
        QString ds;
        QStringList l;
        l = n.split("|");
        switch(l.count()){
        case 2:
            ds = l.value(1).simplified();
        case 1:
            nm = l.value(0).simplified();
        default:;
        }
        m_E.contents << content(nm, ds);
    }
    m_E.use = use;
    m_E.testable = testable;
}

void Category::setSubCategories_F(const QString & title, const QString & cont, bool use, bool testable)
{    
    m_F.title = title;
    m_F.contents.clear();
    foreach(QString n, cont.split(",")){
        QString nm;
        QString ds;
        QStringList l;
        l = n.split("|");
        switch(l.count()){
        case 2:
            ds = l.value(1).simplified();
        case 1:
            nm = l.value(0).simplified();
        default:;
        }
        m_F.contents << content(nm, ds);        
    }
    m_F.use = use;
    m_F.testable = testable;    
}

void Category::setSubCategories_G(const QString & title, const QString & cont, bool use, bool testable)
{
    m_G.title = title;
    m_G.contents.clear();
    foreach(QString n, cont.split(",")){
        QString nm;
        QString ds;
        QStringList l;
        l = n.split("|");
        switch(l.count()){
        case 2:
            ds = l.value(1).simplified();
        case 1:
            nm = l.value(0).simplified();
        default:;
        }
        m_G.contents << content(nm, ds);
    }
    m_G.use = use;
    m_G.testable = testable;
}

Category::subCategory Category::subCategory_A()
{
    return m_A;
}

QStringList Category::listSubCategoryValues_A()
{
    QStringList lst;
    foreach(content cs, m_A.contents){
        lst << cs.name;
    }
    return lst;
}

Category::subCategory Category::subCategory_B()
{
    return m_B;
}

QStringList Category::listSubCategoryValues_B()
{
    QStringList lst;
    foreach(content cs, m_B.contents){
        lst << cs.name;
    }
    return lst;
}

Category::subCategory Category::subCategory_C()
{
    return m_C;
}

QStringList Category::listSubCategoryValues_C()
{
    QStringList lst;
    foreach(content cs, m_C.contents){
        lst << cs.name;
    }
    return lst;
}

Category::subCategory Category::subCategory_D()
{
    return m_D;
}

QStringList Category::listSubCategoryValues_D()
{
    QStringList lst;
    foreach(content cs, m_D.contents){
        lst << cs.name;
    }
    return lst;
}

Category::subCategory Category::subCategory_E()
{
    return m_E;
}

QStringList Category::listSubCategoryValues_E()
{
    QStringList lst;
    foreach(content cs, m_E.contents){
        lst << cs.name;
    }
    return lst;
}

Category::subCategory Category::subCategory_F()
{
    return m_F;
}

QStringList Category::listSubCategoryValues_F()
{
    QStringList lst;
    foreach(content cs, m_F.contents){
        lst << cs.name;
    }
    return lst;
}

Category::subCategory Category::subCategory_G()
{
    return m_G;
}

QStringList Category::listSubCategoryValues_G()
{
    QStringList lst;
    foreach(content cs, m_G.contents){
        lst << cs.name;
    }
    return lst;
}

bool Category::isEmpty(quint32 c)
{        
    if (m_A.testable && subCategoryValue_A(c)){
        return false;
    }
    if (m_C.testable && subCategoryValue_C(c)){
        return false;
    }
    if (m_D.testable && subCategoryValue_D(c)){
        return false;
    }
    if (m_E.testable && subCategoryValue_E(c)){
        return false;
    }
    if (m_F.testable && subCategoryValue_F(c)){
        return false;
    }
    if (m_G.testable && subCategoryValue_G(c)){
        return false;
    }

    return true;
}

