#include "clipbox.h"
#include "remark.h"
#include "global.h"

#include <QTextStream>
#include <QDir>

ClipBox::ClipBox(const QString &name, MyUnit* parent) : AnyBox(name, parent)
{
    m_dateFormat = "dd.MM.yyyy";
    m_useSubFile = true;
}

void ClipBox::setCategoryLabels()
{
    Category cat;

    cat.setSubCategories_A(tr("Which"), tr("water,sky,land,flora,fauna,humans,build,wheel,item"), true, true);
    cat.setSubCategories_C(tr("Where"), tr("inside,outside"), true, false);
    cat.setSubCategories_D(tr("Daytime"), tr("night,morning,day,evening"), true, false);
    cat.setSubCategories_E(tr("Season"), tr("winter,spring,summer,autumn"), true, false);

    QString myCat = m_myCategories;

    myCat.replace("blank", tr("blank"));
    myCat.replace("home", tr("home"));
    myCat.replace("music", tr("music"));
    myCat.replace("empty_A", tr("empty_A"));
    myCat.replace("empty_B", tr("empty_B"));
    myCat.replace("empty_C", tr("empty_C"));
    myCat.replace("empty_D", tr("empty_D"));
    myCat.replace("empty_E", tr("empty_E"));
    myCat.replace("empty_F", tr("empty_F"));
    myCat.replace("empty_A", tr("empty_G"));
    myCat.replace("empty_B", tr("empty_H"));
    myCat.replace("empty_C", tr("empty_I"));
    myCat.replace("empty_D", tr("empty_J"));
    myCat.replace("empty_E", tr("empty_K"));
    myCat.replace("empty_F", tr("empty_L"));
    myCat.replace("empty_F", tr("empty_M"));
    cat.setSubCategories_F(tr("Picture"), myCat, true, false);

    cat.setSubCategories_G(tr("Method"), tr("pose,reporting"), true,false);

    m_category = cat;

}

void ClipBox::makeSubFile(QString s)
{
    Remark r(s.split("\n").at(0));
    QString subFilename;
    subFilename = completeName() + QDir::separator() + r.re() + QDir::separator() + r.ma() +
                  QDir::separator() + r.rk() + "." + SUB_FILE_EXT;

    QFile f(subFilename);

    QTextStream st(&f);
    st.setCodec("UTF-8");
    st.setGenerateByteOrderMark(false);

    if (initOk()) {
        if (f.open(QIODevice::WriteOnly | QIODevice::Text)) {
            st << "FORMAT=0" << endl;
            st << "0 0" << endl;
            st << s << endl;
            f.close();
        }
    }
}
