#ifndef DESCRIBEDIALOG_H
#define DESCRIBEDIALOG_H

#include "ui_describedialog.h"
#include "mywrdfile.h"
#include "anybox.h"
#include "entry.h"

#include <QFrame>
#include <QFile>
#include <QProcess>

/*
  Составление описания записи (widget)
*/

class DescribeDialog :  public QFrame, public Ui::DescribeDialogGUI
{
    Q_OBJECT

    MyWrdFile *wrd;
    AnyBox *m_box;    

    QHash<QString,QString> *hash;    

    QString m_tmpFilename;
    QFile m_tmpFile;
    QProcess *process;

    Entry *m_currentEntry;
    int m_corrIndex;
    int m_uncorrIndex;

    QString template_info;   

    QString tabHdrCategory;
    QString tabHdrKeyword;
    QString tabHdrTitle;
    QString tabHdrDate;
    QString tabHdrPrint;
    QString modifySymbol;

    struct description{
        quint32 category;
        QString keywordList;
        QString title;
        QDate   date;
        uint    print;
    };

    description original;
    description current;

    QList<Entry*> m_correctedList;
    QList<Entry*> m_uncorrectedList;

    QString originalCategoryText;
    QString originalKeywordListText;
    QString originalTitleText;

    QString currentKey;

    QString setCategory(quint32);    
    QString setKeyword(QString);
    QString setTitle(QString);
    void setDate(QDate);
    void setPrint(uint);

    void setModeCategoryClearButton();
    void setModeCategoryOriginalButton();

    void splitUp(const QString &, QString &, QString &);
    void setModeKeywordClearButton();
    void setModeKeywordOriginalButton();
    void setModeKeywordChooseButton();
    void setModeListWidget();
    void setModeSynonymListWidget();

    void setModeTitleClearButton();
    void setModeTitleOriginalButton();

    void setModeDateTodayButton();
    void setModeDateOriginalButton();

    void setModeHardcopyClearButton();
    void setModeHardcopyOriginalButton();

    void setModePrevCorrButton();
    void setModeNextCorrButton();
    void setModePrevUncorrButton();
    void setModeNextUncorrButton();

    void setModeApplyButton();

    bool eventFilter(QObject *, QEvent *);

    void setTextBrowser(Entry*);
    void demonstration(Entry*);

    void setInfoString();

    void changeEvent(QEvent *);
    void retranslateThis();

signals:    
    void dataReady(quint32, QString, QString);

private slots:
    //Category
    void updateCurrentCategory();    
    void pressCategoryClearButton();
    void pressCategoryOriginalButton();
    //Keyword
    void likeKeywords(QString);
    void likeSynonyms(QString);
    void pressAddKeywordButton();
    void pressAddSynonymButton();
    void choiceKeyword(QListWidgetItem*);
    void pressChooseButton();
    void synonymSelect();
    void pressRemoveSynonymButton();
    void keywordSelect();
    void pressRemoveListButton();
    void pressClearKeywordButton();
    void pressOriginalKeywordButton();
    //Title
    void updateCurrentTitle();        
    void pressTitleClearButton();
    void pressTitleOriginalButton();
    //Date
    void updateSelectedDate(QDate);
    void pressDateTodayButton();
    void pressDateOriginalButton();
    //Print
    void updateCurrentHardcopy();    
    void pressHardcopyClearButton();
    void pressHardcopyOriginalButton();
    //    
    void pressPrevCorrButton();
    void pressNextCorrButton();

    void pressPrevUncorrButton();
    void pressNextUncorrButton();
    //
    void pressApplyButton();
    void pressSaveButton();    

public:    
    DescribeDialog(AnyBox* , QFrame*);
    ~DescribeDialog();

    void setTabVisible(int);    

};

#endif // DESCRIBEDIALOG_H


