#include "entry.h"
#include "global.h"
#include "remark.h"

Entry::Entry()
{
    m_entry.clear();
    m_Ok = false;
}

Entry::Entry(QString a)
{
    if (a.isEmpty()) {
        m_entry.clear();
        m_Ok = false;
    } else {
        m_entry = a.split("~");
        m_Ok = test();
    }
}

void Entry::setEntry(QString a)
{
    if (a.isEmpty()) {
        m_entry.clear();
        m_Ok = false;
    } else {
        m_entry = a.split("~");
        m_Ok = test();
    }
}

bool Entry::Ok()
{
    return m_Ok;
}

bool Entry::test()
{
    if (m_entry.count() == 10 && Remark(m_entry[REMARK]).Ok()) {
        return true;
    } else {
        return false;
    }
}

QString Entry::getField(int i)
{
    if (m_Ok) {
        return m_entry[i];
    } else {
        return "";
    }
}

QString Entry::simpleName()
{
    if (m_Ok) {
        Remark a;
        a = m_entry[REMARK];
        return a.rk();
    } else {
        return "";
    }
}

void Entry::setField(int i, QString v)
{
    m_entry[i] = v;
    m_Ok = test();
}

QString Entry::getAllFields()
{
    if (m_Ok) {
        return m_entry.join("~");
    } else {
        return "";
    }
}

QString Entry::remarkFileName()
{
    QString s;
    s = m_entry[ORIGINALFILENAME].section(".",-1,-1);
    return m_entry[REMARK] + "." + s;
}

QString Entry::originalFileName()
{
    return m_entry[ORIGINALFILENAME];
}

