#ifndef ENTRY_H
#define ENTRY_H

#include <QString>
#include <QStringList>

/*
  Запись
  Поля записи: SESSION, REMARK, RESEMBLE, CHECKSUM, PRINT, CATEGORY, KEYWORD, ORIGINALFILENAME, TITLE, DATE
  Содержит список значений полей записи и корректна ли запись (m_Ok)
  Метод test() проверяет запись на корректность и устанавливает флаг m_Ok
*/

class Entry
{
    QStringList m_entry;
    bool m_Ok;

    bool test();

public:
    Entry();
    Entry(QString);                 // параметр - строка, содержащая поля, разделенные '~'

    bool Ok();                      // Проверка корректности записи
    void setEntry(QString);
    QString getField(int);          // получить значение заданного поля
    QString simpleName();           // получить "простое" имя записи (RK от поля REMARK)
    void setField(int, QString);    // установить значение заданного поля
    QString getAllFields();         // получить все поля в виде одной строки, разделенных '~'

    QString remarkFileName();       // получить поле REMARK с добавленным к нему асширением от ORIGINALFILENAME
    QString originalFileName();     // получить поле ORIGINALFILENAME

};

#endif // ENTRY_H
