#ifndef FIRSTDIALOG_H
#define FIRSTDIALOG_H

#include "ui_firstdialog.h"
#include "anybox.h"

#include <QProcess>
#include <QFile>

/*
  Сбор исходных файлов из различных источников в один каталог - источник для mybox
  Исходные файлы остаются неизмененными и остаются на своих местах, просто создается их копия
*/

class FirstDialog : public QFrame, public Ui::FirstDialogGUI
{
    Q_OBJECT

    AnyBox *m_box;    

    QStringList device;
    int countDetectFiles;
    int countSelectFiles;
    quint64 totalSize;
    QStringList extension;

    QFile m_sldFile;
    QProcess *process;

    enum {no = -1, off, on};

    struct set_D{
        QString text;
        QString device;
        int count;
        int mode;        
    };

    struct set_F{
        QString text;
        QString name;
        int mode;
        qint64 size;
    };

    QList<set_D> devices;
    QList<set_F> files;

    bool eventFilter(QObject *, QEvent *);
    void changeEvent(QEvent *event);
    void retranslateThis();

private slots:
    void detectNothing();
    void detectSubstract();
    void detectAdd();
    void detectAll();                
    void detectAgree();

    void enableDetectNothing();
    void enableDetectSubstract(QListWidgetItem*);
    void enableDetectAdd(QListWidgetItem*);
    void enableDetectAll();
    void enableDetectAgree();

    void selectNothing();
    void selectSubstract();
    void selectAdd();
    void selectAll();
    void selectAgree();

    void enableSelectNothing();
    void enableSelectSubstract();
    void enableSelectAdd();
    void enableSelectAll();
    void enableSelectAgree();

public:
    FirstDialog(AnyBox*, QFrame*);
    ~FirstDialog();
    void detecting();

signals:    

public slots:

};

#endif // FIRSTDIALOG_H
