#ifndef GLOBAL_H
#define GLOBAL_H

#include <QString>

enum {ALL = -1, SESSION, REMARK, RESEMBLE, CHECKSUM, PRINT,
      CATEGORY, KEYWORD, ORIGINALFILENAME, TITLE, DATEOFCREATION};

const int ABC_WIDTH = 2;

const QString ABC_CHAR = "[a-z]";
const QString ABC_NAME = ABC_CHAR + "{2}";
const QString ABC_REMARK = ABC_CHAR + "{6}";

const QString ABC_WRD = ABC_CHAR + "{4}";

// Names
//-------
const QString NAME_PHOTO = "photo";
const QString NAME_CLIP  = "clip";
const QString NAME_MUSIC = "music";
const QString NAME_BOOK  = "library";

const QString NAME_SRC_FOLDER = "_src";
const QString NAME_DST_FOLDER = "_dst";
const QString NAME_SLD_FOLDER = "_sld";

const QString NAME_LOG_FILE = "log";
const QString NAME_SSS_FILE = "sss";
const QString NAME_WRD_FILE = "wrd";
const QString NAME_TMP_FILE = "tmp";
const QString NAME_ABC_FILE = "abc";

const QString NAME_PHOTO_PLAYLIST_EXT = "sld";
const QString NAME_CLIP_PLAYLIST_EXT  = "mpl";
const QString NAME_MUSIC_PLAYLIST_EXT = "apl";
const QString NAME_BOOK_PLAYLIST_EXT  = "tpl";

const QString SUB_FILE_EXT  = "sub";

const QString SIGN_INV = "~";

const int MAX_NUM_OF_SHOW = 1000;

// Keys
//------

const QString KEY_GENERAL = "main";
const QString KEY_PHOTO = "photo";
const QString KEY_CLIP  = "clip";
const QString KEY_MUSIC = "music";
const QString KEY_BOOK  = "library";


const QString KEY_BOX_DIR = "/boxDir";
const QString KEY_CPY_DIR = "/cpyDir";
const QString KEY_BURN_CD = "/burnCD";
const QString KEY_FIRST_DIR = "/firstDir";
const QString KEY_EXTRACT_META_APP = "/extractMetaApp";
const QString KEY_LANGUAGE = "/language";

const QString KEY_EXT = "/ext";
const QString KEY_EXT_PLAYLIST = "/extPlayList";
const QString KEY_PREVIEW_APP = "/previewApp";
const QString KEY_PRESENT_APP = "/presentApp";
const QString KEY_EXTRACT_APP = "/extractApp";
const QString KEY_CATEGORIES = "/categories";

// Values
//--------
const QString PHOTO_EXT = "jpg, jpeg, raf, png";
const QString BOOK_EXT  = "doc,txt,djvu,djv,pdf,fb2";
const QString CLIP_EXT  = "mp4,avi,flv";
const QString MUSIC_EXT = "mp3,wav";
const QString LANGUAGE  = "en";

#ifdef Q_OS_WIN32
const QString BOX_DIR_DEFAULT = "c:\\mybox";
const QString CPY_DIR_DEFAULT = "d:\\mybox_backup";
const QString CMD_BURN_CD_DEFAULT = "\"c:\\Program Files\\CommandBurner\\cmdburn.exe\" burn /l %1 /d %2 /erase /eject";
const QString FIRST_DIR_DEFAULT = "f:, h:";
const QString EXTRACT_META_APP = "exiftool.exe -f -d \"%d.%m.%Y|%H:%M\" -p \"$FileName|$DateTimeOriginal\" %1";

const QString PHOTO_PREVIEW_APP = "\"c:\\Program Files\\IrfanView\\i_view32.exe\" /filelist=%1 /hide=7";
const QString PHOTO_PRESENT_APP = "\"c:\\Program Files\\IrfanView\\i_view32.exe\" /slideshow=%1";

const QString BOOK_PREVIEW_APP  = "mybookreader.exe -list %1";
const QString BOOK_PRESENT_APP  = "mybookreader.exe -list %1";

const QString CLIP_PREVIEW_APP  = "\"c:\\Program Files\\MPlayer\\mplayer.exe\" -playlist %1";
const QString CLIP_PRESENT_APP  = "\"c:\\Program Files\\MPlayer\\mplayer.exe\" -playlist %1";

const QString MUSIC_PREVIEW_APP = "mymplayer.exe -list %1";
const QString MUSIC_PRESENT_APP = "mymplayer.exe -list %1";
#else
const QString BOX_DIR_DEFAULT = "/usr/share/mybox";
const QString CPY_DIR_DEFAULT = "/usr/share/mybox_cpy";
const QString CMD_BURN_CD_DEFAULT = "cmdBurnCD %1 %2";
const QString FIRST_DIR_DEFAULT = "/mnt, /dist, /home/John";
const QString EXTRACT_META_APP = "exiftool -f -d \"%d.%m.%Y|%H:%M\" -p \"$FileName|$DateTimeOriginal\" %1";

const QString PHOTO_PREVIEW_APP = "cmdPreviewGeeqie %1";
const QString PHOTO_PRESENT_APP = "cmdPresentGeeqie %1";

const QString BOOK_PREVIEW_APP  = "mybookreader -list %1";
const QString BOOK_PRESENT_APP  = "mybookreader -list %1";

const QString CLIP_PREVIEW_APP  = "mplayer -playlist %1";
const QString CLIP_PRESENT_APP  = "mplayer -playlist %1";

const QString MUSIC_PREVIEW_APP = "mymplayer -list %1";
const QString MUSIC_PRESENT_APP = "mymplayer -list %1";
#endif

const QString PHOTO_CATEGORIES(
        "chronicle|-,"
        "informative|-,"
        "event|-,"
        "situation|-,"
        "moment|-,"
        "detail|-,"
        "pictorial|-,"
        "composition|-,"
        "series|-,"
        "essay|-,"
        "empty_A|-,"
        "empty_B|-,"
        "empty_C|-,"
        "empty_D|-,"
        "empty_E|-,"
        "empty_F|-"
        );

const QString BOOK_CATEGORIES(
        "blank|-,"
        "belles|-,"
        "information|-,"
        "popular_science|-,"
        "periodical|-,"
        "educational|-,"
        "technical|-,"
        "folklore|-,"
        "fantasy|-,"
        "detective|-,"
        "adventure|-,"
        "creation|-,"
        "art|-,"
        "empty_A|-,"
        "empty_B|-,"
        "empty_C|-"
        );

const QString CLIP_CATEGORIES(
        "blank|-,"
        "home|-,"
        "music|-,"
        "empty_A|-,"
        "empty_B|-,"
        "empty_C|-,"
        "empty_D|-,"
        "empty_E|-,"
        "empty_F|-,"
        "empty_H|-,"
        "empty_I|-,"
        "empty_J|-,"
        "empty_K|-,"
        "empty_L|-,"
        "empty_M|-,"
        "empty_N|-"
        );

const QString MUSIC_CATEGORIES(
        "blank|-,"
        "classic|-,"
        "folk|-,"
        "pop|-,"
        "baby|-,"
        "blues|-,"
        "jazz|-,"
        "rock|-,"
        "electronic|-,"
        "retro|-,"
        "dancing|-,"
        "empty_A|-,"
        "empty_B|-,"
        "empty_C|-,"
        "empty_D|-,"
        "empty_E|-"
        );

#endif // GLOBAL_H
