#include "musicbox.h"
#include "remark.h"
#include "global.h"

#include <QDir>
#include <QTextStream>

MusicBox::MusicBox(const QString &name, MyUnit* parent) : AnyBox(name, parent)
{
    m_dateFormat = "yyyy";
    m_useSubFile = true;
}

void MusicBox::setCategoryLabels()
{
    Category cat;

    cat.setSubCategories_A("A", "A,B,C,D,E,F,G,H,I", false, false);
    cat.setSubCategories_C(tr("Home country"), tr("native,foreign"), true, false);
    cat.setSubCategories_D(tr("Perfomance"), tr("blank,instrumental,vocal,mixed"), true, false);
    cat.setSubCategories_E(tr("Number of performer"), tr("blank,solo,small,great"), true, false);

    QString myCat = m_myCategories;

    myCat.replace("blank", tr("blank"));
    myCat.replace("classic", tr("classic"));
    myCat.replace("folk", tr("folk"));
    myCat.replace("pop", tr("pop"));
    myCat.replace("baby", tr("baby"));
    myCat.replace("blues", tr("blues"));
    myCat.replace("jazz", tr("jazz"));
    myCat.replace("rock", tr("rock"));
    myCat.replace("electronic", tr("electronic"));
    myCat.replace("retro", tr("retro"));
    myCat.replace("dancing", tr("dancing"));
    myCat.replace("empty_A", tr("empty_A"));
    myCat.replace("empty_B", tr("empty_B"));
    myCat.replace("empty_C", tr("empty_C"));
    myCat.replace("empty_D", tr("empty_D"));
    myCat.replace("empty_E", tr("empty_E"));
    cat.setSubCategories_F(tr("Genre"), myCat, true, true);

    cat.setSubCategories_G("G", "A,B", false,false);

    m_category = cat;

}

quint32 MusicBox::startValueCategory(MySourceFile *file)
{
    quint32 result = 0;

    return result;

}

void MusicBox::makeSubFile(QString s)
{

    QStringList l;
    l = s.split("\n");

    Remark r(l.takeFirst());

    QStringList m;
    QStringList titleAndAuthor;
    if (!l.isEmpty()) {
        titleAndAuthor = l.takeFirst().split(",");

        switch(titleAndAuthor.count()){
        case 1:
            m << titleAndAuthor.at(0);
            m << "";
            break;
        case 2:
            m << titleAndAuthor.at(0);
            m << titleAndAuthor.at(1);
            break;
        default:
            m << "" << "";
        }
    }

    if (!l.isEmpty()) {
        m << l.takeFirst();
    }

    QString subFilename;
    subFilename = completeName() + QDir::separator() + r.re() + QDir::separator() + r.ma() +
                  QDir::separator() + r.rk() + "." + SUB_FILE_EXT;

    QFile f(subFilename);

    QTextStream st(&f);
    st.setCodec("UTF-8");
    st.setGenerateByteOrderMark(false);

    if (initOk()) {
        if (f.open(QIODevice::WriteOnly | QIODevice::Text)) {
            st << m.join("\n") << endl;
            f.close();
        }
    }
}
