#ifndef MYBOX_H
#define MYBOX_H

#include "basefolder.h"

#include "photobox.h"
#include "bookbox.h"
#include "clipbox.h"
#include "musicbox.h"

#include "mysrcfolder.h"
#include "mysettings.h"

#include <QWidget>
#include <QEvent>

/*
  MyBox
  Создает MyBox, используя настройки программы
  Проверяет возможность создания отдельных элементов (initStatus(...))
  Обновляет настройки программы updateSettings()
*/

class MyBox : public QWidget
{
    Q_OBJECT

    MySettings *m_set;

    BaseFolder *m_baseFolder;
    PhotoBox *m_photoBox;
    BookBox *m_bookBox;
    ClipBox *m_clipBox;
    MusicBox *m_musicBox;

    MySrcFolder *m_srcFolder;

public:    
    MyBox(MySettings *set);

    bool initStatus(QString &message);
    BaseFolder* baseFolder();
    void updateSettings();
    void setWelcomeLabels();
};

#endif // MYBOX_H
