#include "mylogfile.h"
#include <QTextStream>
#include <QFile>
#include <QDateTime>

MyLogFile::MyLogFile(QString name, MyUnit* parent) : MyFile(name, parent)
{
}

bool MyLogFile::add(const QString &line)
{    
    QFile f(this->completeName());
    QTextStream st(&f);
    st.setCodec("UTF-8");
    st.setGenerateByteOrderMark(false);

    bool result = false;

    if (initOk()) {
        if (f.open(QIODevice::Append | QIODevice::Text)) {
            result = true;
            st << line << endl;
            f.close();
        }
    }
    return result;
}

MyLogFile &MyLogFile::operator<<(const QString &line)
{
    QFile f(this->completeName());
    QTextStream st(&f);
    st.setCodec("UTF-8");
    st.setGenerateByteOrderMark(false);

    if (initOk()) {
        if (f.open(QIODevice::Append | QIODevice::Text)) {            
            st << line << endl;
            f.close();
        }
    }
    return *this;
}

void MyLogFile::openLog(QString name)
{
    m_name = name;

    QString s("--- %1 OPEN : %2 ---");
    *this << s.arg(m_name, QDateTime::currentDateTime().toString("dd.MM.yyyy hh:mm:ss.zzz"));
}

void MyLogFile::closeLog()
{
    QString s("--- %1 CLOSE: %2 ---\n");
    *this << s.arg(m_name, QDateTime::currentDateTime().toString("dd.MM.yyyy hh:mm:ss.zzz"));
}

