#ifndef MYSETDIALOG_H
#define MYSETDIALOG_H

#include "ui_mysetdialog.h"
#include "global.h"
#include "mysettings.h"
#include "mysettab.h"

#include <QDialog>

/*
  Установка настроек программы (widget)
  Содержит настройки отдельных anybox (mysettab)
*/

class FirstTable : public QTableWidget
{
    Q_OBJECT

    void showEvent (QShowEvent *event);
    void resizeEvent(QResizeEvent *event);
    void setColWidth();

    bool event(QEvent *);

public:   
    FirstTable(QWidget *parent);

signals:
    void focusLose(bool);
};

class MySetDialog : public QDialog, public Ui::MySetDialog
{
    Q_OBJECT

    MySetTab *photoTab;
    MySetTab *bookTab;
    MySetTab *videoTab;
    MySetTab *musicTab;   

    MySettings *myset;
    QStringList m_listOfFirstDirs;

    QString m_originalBoxDir;

    void setStatus(int);

    FirstTable *firstDirTable;

    bool eventFilter(QObject *, QEvent *);    

public:
    explicit MySetDialog(MySettings *s, QWidget *parent = 0);
    void saveSettings();
    bool needReboot();    

signals:

private slots:
    void setBoxDirStatus(QString);
    void setCpyDirStatus(QString);
    void setBurnAppStatus(QString);
    void setExtractAppStatus(QString);

    void pressBoxDirDefaultButton();
    void pressCpyDirDefaultButton();
    void pressBurnAppDefaultButton();
    void pressExtractAppDefaultButton();

    void setModeBoxDirDefaultButton(QString);
    void setModeCpyDirDefaultButton(QString);
    void setModeBurnAppDefaultButton(QString);
    void setModeExtractAppDefaultButton(QString);

    void pressFirstDirAddButton();
    void pressFirstDirDeleteButton();

    void setModeFirstAddButton();
    void setModeFirstDeleteButton();

    void tableChange(QTableWidgetItem *c);
    void setFocusAfterFirstTable(bool);

    void setModeOkButton(QString);

public slots:

};

#endif // MYSETDIALOG_H
