#include "mysettings.h"
#include "global.h"

#include <QStringList>

MySettings::MySettings(const QString &org, const QString &app, const SettingsMap &sets) :
        QSettings(QSettings::IniFormat, QSettings::UserScope, org, app)
{    
    m_defaultValues = sets;

    foreach(QString key, sets.keys()){
        if (!contains(key)){
            setValue(key, sets[key]);
        }
    }

    QString s;
    s = value(KEY_PHOTO + KEY_CATEGORIES).toString();
    if (s.split(",").count() != 16){
        setValue(KEY_PHOTO + KEY_CATEGORIES, m_defaultValues.value(KEY_PHOTO + KEY_CATEGORIES));
    }
    s = value(KEY_BOOK + KEY_CATEGORIES).toString();
    if (s.split(",").count() != 16){
        setValue(KEY_BOOK + KEY_CATEGORIES, m_defaultValues.value(KEY_BOOK + KEY_CATEGORIES));
    }
    s = value(KEY_CLIP + KEY_CATEGORIES).toString();
    if (s.split(",").count() != 16){
        setValue(KEY_CLIP + KEY_CATEGORIES, m_defaultValues.value(KEY_CLIP + KEY_CATEGORIES));
    }
    s = value(KEY_MUSIC + KEY_CATEGORIES).toString();
    if (s.split(",").count() != 16){
        setValue(KEY_MUSIC + KEY_CATEGORIES, m_defaultValues.value(KEY_MUSIC + KEY_CATEGORIES));
    }
}

MySettings::MySettings(const QString &fileName, const SettingsMap &sets) :
        QSettings(fileName, QSettings::IniFormat)
{
    m_defaultValues = sets;

    foreach(QString key, sets.keys()){
        if (!contains(key)){
            setValue(key, sets[key]);
        }
    }

    QString s;
    s = value(KEY_PHOTO + KEY_CATEGORIES).toString();
    if (s.split(",").count() != 16){
        setValue(KEY_PHOTO + KEY_CATEGORIES, m_defaultValues.value(KEY_PHOTO + KEY_CATEGORIES));
    }
    s = value(KEY_BOOK + KEY_CATEGORIES).toString();
    if (s.split(",").count() != 16){
        setValue(KEY_BOOK + KEY_CATEGORIES, m_defaultValues.value(KEY_BOOK + KEY_CATEGORIES));
    }
    s = value(KEY_CLIP + KEY_CATEGORIES).toString();
    if (s.split(",").count() != 16){
        setValue(KEY_CLIP + KEY_CATEGORIES, m_defaultValues.value(KEY_CLIP + KEY_CATEGORIES));
    }
    s = value(KEY_MUSIC + KEY_CATEGORIES).toString();
    if (s.split(",").count() != 16){
        setValue(KEY_MUSIC + KEY_CATEGORIES, m_defaultValues.value(KEY_MUSIC + KEY_CATEGORIES));
    }
}


QVariant MySettings::defaultValue(const QString &key)
{
    return m_defaultValues[key];
}
