#ifndef MYSOURCEFILE_H
#define MYSOURCEFILE_H

#include <QCryptographicHash>
#include <QDate>
#include <QTime>

#include "myfile.h"

/*
  Исходный файл
  Основан на MyUnit
  Содержит сведения о расширении файла (m_ext), сумме md5 (m_checkSum) и данных о времени (m_exifTime)
  и дате (m_exifDate). Дата и время заполняется из даты и времени последнего изменения файла.
  Время может быть скорректированно методом setExifTime(...), а дата - методом setExifDate(...)
*/

class MySourceFile : public MyUnit
{
    QDate m_exifDate;
    QTime m_exifTime;
    QString m_checkSum;
    QString m_ext;

public:    
    MySourceFile(const QString &name, MyUnit* parent);

    QDate exifDate();
    QTime exifTime();
    QString checkSum();
    QString ext();

    void setExifDate(const QDate &);
    void setExifTime(const QTime &);
};

#endif // MYSOURCEFILE_H
