#ifndef MYSPLASH_H
#define MYSPLASH_H

#include <QWidget>
#include <QPixmap>
#include <QLabel>
#include <QPalette>
#include <QEventLoop>

/*
  Заставка программы
*/

class MySplash: public QWidget
{
    Q_OBJECT

    QEventLoop loop;

    QPixmap *m_pixmap;
    QLabel *m_background;
    QLabel *m_message;

    QPalette m_palette;

    int m_displayTime;

    void keyPressEvent(QKeyEvent *event);
    void mousePressEvent(QMouseEvent *event);


public:
    MySplash(const QString &,
             Qt::Alignment alignment = Qt::AlignRight | Qt::AlignBottom,
             const QColor &color = Qt::white
            );
    void setDisplayMessageTime(int);
    void showMessage(const QString &);
    void activateUserAction();

signals:
    void workComplete();

};

#endif // MYSPLASH_H
