#ifndef MYSRCFOLDER_H
#define MYSRCFOLDER_H

#include "myfolder.h"
#include "mysourcefile.h"

#include <QProcess>

/*
  Каталог файлов, которые будут размещены в mybox
  Основан на MyFolder
  При создании перебираются файлы из каталога, соответствующего этому элементу, и определяется
  дата и время их создания из exif. Также создаются дочерние элементы  MySourceFile, которые
  соответствуют этим файлам. Если полученные дата и время корректны, то происходит обновление
  значений в MySourceFile

  <MySrcFolder>
    |
    |-- <MySourceFile>
    |-- <MySourceFile>
   ...

*/

class MySrcFolder : public MyFolder
{
    Q_OBJECT

    QString m_extractApp;
    QString m_sourceDir;
    QProcess *process;

    void addFiles();

private slots:
    void setDateAndTime();

public:    
    MySrcFolder(QString extractApp, const QString &name, MyUnit* parent);
    ~MySrcFolder();
    QList<MySourceFile*> getInConformityExt(const QSet<QString> &exts);
    void setExtractApp(QString);

    void refresh();
};

#endif // MYSRCFOLDER_H
