#ifndef MYSSSFILE_H
#define MYSSSFILE_H

#include "myfile.h"

#include <QMap>

/*
  Файл с информацией о сессиях
  Основан на MyFile
  Каждая строка в файле, соответствующего этому элементу, описывает одну сессию
  Строка разделена на четыре поля символом '~'
  Поля: номер сессии, дата создания, принадлежность к конкретному anybox, краткое описание сессии
*/

class MySssFile : public MyFile
{
    int m_currentSessionNumber;
    int m_countSessions;

    QMap<uint, QString> m_sessionDateCreation;
    QMap<uint, QString> m_sessionAnnatation;

public:
    MySssFile(const QString &name, MyUnit* parent);

    enum { NO, CREATION_DATE, TYPE, ANNOTATION };

    QString currentSessionNumber();
    QString countSessions();
    bool add(const QString &boxName, QString ann);
    QString sessionDateCreation(uint);
    QString sessionAnnotation(uint);    
};

#endif // MYSSSFILE_H
