#ifndef MYTMPFILE_H
#define MYTMPFILE_H

#include "myfile.h"
#include "mywrdfile.h"
#include "anybox.h"

#include <QMap>

/*
  Шаблоны поиска
  Основан на MyFile
  Работает с соответствующим файлом на диске
*/

class MyTmpFile : public MyFile
{
    Q_OBJECT

public:
    struct task{
        QString remark;
        QString category;
        QString keyword;
        QString date;
        QString session;
        QString print;
        QString title;
        bool addTask;
    };
    typedef QList<task> tasks;

    enum {OWN, NAME, DESCRIBE} ;

private:

    MyWrdFile* wrd;

    QString symbolSession;
    QString symbolRemark;
    QString symbolPrint;
    QString symbolCategory;
    QString symbolKeyword;
    QString symbolTitle;
    QString symbolDate;
    QString symbolSearch;
    QString symbolAddTask;

    QString checkedSession;
    QString checkedRemark;
    QString checkedPrint;
    QString checkedCategory;
    QString checkedKeyword;
    QString checkedTitle;
    QString checkedDate;

    QMap<QString, tasks> m_templates;
    QMap<QString, QString> m_describe;
    QMap<QString, QString> m_own;

    bool checkTask(AnyBox*, task);

public:
    MyTmpFile(const QString &name, MyUnit* parent);

    void loadTemplates(QString);

    QMap<QString, tasks>* templates();
    QMap<QString, QString>* describes();
    tasks getTask(QString);
    void addTask(QString, QString, QString, tasks);
    QString viewTask(QString, bool*);
    int templatesCount();
    int templatesCount(QString);
    QString own(QString);

};

#endif // MYTMPFILE_H
