#include "myunit.h"
#include <QDir>

MyUnit::MyUnit(const QString &name, MyUnit *parent) : QObject(parent)
{    
    m_initOk=false;
    m_name = name;
    setObjectName(m_name);

    if (parent) {
        m_path = parent->completeName() + QDir::separator();
    } else {
        m_path = "";        
    }
}

QString MyUnit::path()
{    
    return m_path;
}

QString MyUnit::name()
{
    return m_name;
}

QString MyUnit::completeName()
{
    QString result;
    result = m_path + m_name;
    return result;
}

bool MyUnit::initOk()
{
    return m_initOk;
}

QString MyUnit::type()
{
    return m_type;
}

MyUnit* MyUnit::unit(const QString &unitName)
{
    MyUnit* result;

    QObject *currentUnit;
    QObject *parentUnit;
    currentUnit = this;
    parentUnit = currentUnit->parent();
    while (parentUnit){
        currentUnit = parentUnit;
        parentUnit = currentUnit->parent();
    }
    if (currentUnit->objectName() == unitName) {
        result = static_cast<MyUnit*>(currentUnit);
    } else {
        result = currentUnit->findChild<MyUnit*>(unitName);
    }

    return result;
}

MyUnit* MyUnit::baseUnit()
{
    MyUnit* result;

    QObject *currentUnit;
    QObject *parentUnit;
    currentUnit = this;
    parentUnit = currentUnit->parent();
    while (parentUnit){
        currentUnit = parentUnit;
        parentUnit = currentUnit->parent();
    }
    result = static_cast<MyUnit*>(currentUnit);

    return result;
}

