#ifndef MYWRDFILE_H
#define MYWRDFILE_H

#include "global.h"
#include "myfile.h"

#include <QHash>
#include <QStringList>

/*
  Словарь
  Основан на MyFile
  Работает с соответствующим файлом на диске
*/

class MyWrdFile : public MyFile
{
    QHash<QString,QString> words;
    QHash<QString,QString> newWords;    
    QStringList freeWords;

    bool needUpdate;

public:
    MyWrdFile(const QString &name, MyUnit* parent);
    bool addNewWord(QString);
    bool addSynonym(QString, QString);
    bool setSynonym(QString, QStringList);
    bool storeAllWords();
    bool storeNewWords();
    void setNeedUpdate(bool);
    QString replaceWordToKey(QString);
    bool wordExist(QString);
    QString getKey(QString);
    QHash<QString,QString>* getWords();
    QStringList likeBegin(QString);
    QStringList allWords();

    bool storeWords();
};

#endif // MYWRDFILE_H
