#include "remark.h"
#include "global.h"
#include <QRegExp>

Remark::Remark()
{
    m_remark = "";
    m_Ok = false;
}

Remark::Remark(QString a)
{
    m_remark = a;
    m_Ok = test();
}

void Remark::setRemark(QString a)
{
    m_remark = a;
    m_Ok = test();
}

QString Remark::remark()
{
    return m_remark;
}

bool Remark::Ok()
{    
    return m_Ok;
}

bool Remark::test()
{
    QRegExp exp(ABC_REMARK);
    return exp.exactMatch(m_remark);
}

QString Remark::re()
{
    if (m_Ok) {
        return m_remark.left(ABC_WIDTH);
    } else {
        return "";
    }
}

QString Remark::ma()
{
    if (m_Ok) {
        return m_remark.mid(ABC_WIDTH,ABC_WIDTH);
    } else {
        return "";
    }
}

QString Remark::rk()
{
    if (m_Ok) {
        return m_remark.right(ABC_WIDTH);
    } else {
        return "";
    }
}

QString Remark::rema()
{
    if (m_Ok) {
        return m_remark.left(ABC_WIDTH*2);
    } else {
        return "";
    }
}
