#ifndef RESEMBLEDIALOG_H
#define RESEMBLEDIALOG_H

#include "anybox.h"
#include "ui_resembledialog.h"

#include <QMap>
#include <QSet>
#include <QFrame>

/*
  Объединение похожих записей (widget)
*/

class ResembleDialog : public QFrame , public Ui::ResembleDialogGUI
{
    Q_OBJECT

    AnyBox* m_box;        

    int m_subset;
    bool m_applyNotPressed;

    QMap<QString, Entry*> m_poolEntries;
    QMap<QString, Entry*> m_groupEntries;    
    Entry* m_primeEntry;

    QProcess* m_processPrime;
    QProcess* m_processGroup;
    QProcess* m_processPool;

    QString m_playlistNamePrime;
    QString m_completePlaylistNamePrime;
    QString m_playlistNameGroup;
    QString m_completePlaylistNameGroup;
    QString m_playlistNamePool;
    QString m_completePlaylistNamePool;

    QString m_currentPrime;
    QString m_associateLabel;

    QMap<QString, QSet<QString> > m_cross;
    QStringList m_viewList;

    QFont boldText;

    enum {USE, NOT_USE, MAKE_FREE};
    QMap<QString, int> m_state;

    void setCurrentPrime(QString);

    void showPool();
    void showGroup();

    void setState(QString, int);
    bool eventFilter(QObject *, QEvent *);
    void changeEvent(QEvent *event);
    void retranslateThis();

public:
    ResembleDialog(AnyBox*, QFrame*);
    ~ResembleDialog();

private slots:
    void pressAddButton();
    void pressUniqueButton();
    void pressChangeButton();
    void pressApplyButton();

    void setModeApplyButton();
    void setModeAddButton(int);
    void setModeUniqueButton(int);
    void setModeChangeButton(int);

signals:
    void needUpdateStatus();

};

#endif // RESEMBLEDIALOG_H
