#ifndef SEARCHDIALOG_H
#define SEARCHDIALOG_H

#include <QProcess>

#include "anybox.h"
#include "ui_searchdialog.h"

/*
  Интерактивный поиск (widget)
  Содержит этапы поиска (selectionframe)
*/

class SearchDialog : public QFrame, public Ui::SearchDialogGUI
{
    Q_OBJECT

    AnyBox* m_box;

    QSet<uint> m_sessionNumbers;
    QMap<uint, QDate> m_sessionBegins;
    QMap<uint, QDate> m_sessionEnds;
    QMap<uint, uint> m_sessionCounts;

    QString m_sldFilename;
    QProcess *process; 

    void updateStagesCount();

    void setModePrevStageButton();
    void setModeNextStageButton();

    void closeShowStage();

    void changeEvent(QEvent *event);

public:
    SearchDialog(AnyBox*, QFrame*);
    ~SearchDialog();    
    bool needSave();

    QSet<uint>* sessionNumbers();
    QMap<uint, QDate>* sessionBegins();
    QMap<uint, QDate>* sessionEnds();
    QMap<uint, uint>* sessionCounts();

private slots:
    void pressDeleteStage();
    void pressCreateStage();
    void pressPrevStage();
    void pressNextStage();    
    void setModeSaveButton();
    void setModeCreateStageButton();

    void showStage();
    void warningShowReduce();

public slots:
    void pressSave();

signals:
    void needUpdateStatus();
};

#endif // SEARCHDIALOG_H
