#include "selectdialog.h"

SelectDialog::SelectDialog(AnyBox* b, QFrame* w)  : QFrame(w)
{
    m_box = b;
    setupUi(w);

    boxPixmap->setPixmap(m_box->boxPixmap());

    boxIsEmpty = false; 
    foundRecordsCount = 0;

    // .oO0
    label_A->setHidden(true);
    label_B->setHidden(true);
    label_C->setHidden(true);
    label_D->setHidden(true);
    templateList->setHidden(true);
    templateBrowser->setHidden(true);
    mode->setHidden(true);
    // 0Oo.

    if (m_box->getCount() == 0) {
        boxIsEmpty = true;
        return;
    }

    // .oO0
    label->setHidden(true);
    label_A->setVisible(true);

    if (m_box->markedEntriesCount() == 0){
        onlySelected->setEnabled(false);
    } else {
        onlySelected->setEnabled(true);
    }
    //0Oo.

    m_box->memorizeMarked();

    connect(startButton,SIGNAL(clicked()),this,SLOT(pressStartButton()));
}

SelectDialog::~SelectDialog()
{
    if (foundRecordsCount == 0){
        m_box->restoreMarked();
    } else {
        m_box->uniteSubsets();
        emit needUpdateStatus();
    }
}

void SelectDialog::pressStartButton()
{
    int subset = 0;

    QApplication::setOverrideCursor(Qt::WaitCursor);

    if (onlySelected->checkState() == Qt::Unchecked) {
        m_box->markAllEntries(subset);
    }

    //.oO0
    startButton->setDisabled(true);
    onlySelected->setDisabled(true);
    //0Oo.

    int remarkCount = 0;
    int selectedCount;
    selectedCount = m_box->markedEntriesCount(subset);

    // .oO0
    foundRecords->setText("0");
    if (selectedCount == 0){
        searchProgress->setMaximum(1);
        searchProgress->setValue(1);
    } else {
        searchProgress->setMaximum(selectedCount);
        searchProgress->setValue(0);
    }
    // 0Oo.

    foreach(MyAbcFile* abcFile, m_box->markedAbcFiles(subset)){
//         QApplication::processEvents(QEventLoop::ExcludeUserInputEvents);
        foreach(Entry* entry, abcFile->markedEntries(subset)){
            if (match(entry)){
                foundRecordsCount++;
                // .oO0
                foundRecords->setText(QString::number(foundRecordsCount));
                // 0Oo.
            } else {
                abcFile->unmarkEntry(entry, subset);
            }
            // .oO0
            remarkCount++;
            searchProgress->setValue(remarkCount);
            // 0Oo.
        }
    }

    emit needUpdateStatus();

    QApplication::restoreOverrideCursor();
}

bool SelectDialog::match(Entry* e)
{
    return false;
}

void SelectDialog::changeEvent(QEvent *event)
{
    if (event->type() == QEvent::LanguageChange){
        retranslateUi(this);
        retranslateThis();
    }
    QFrame::changeEvent(event);
}

void SelectDialog::retranslateThis()
{

}
