#ifndef SELECTIONFRAME_H
#define SELECTIONFRAME_H

#include <QFrame>
#include <QList>
#include <QCompleter>

#include "mywrdfile.h"
#include "mytmpfile.h"
#include "anybox.h"
#include "ui_selectionframe.h"

#include "searchdialog.h"

/*
  Этап интерактивного поиска (widget)
*/

class SelectionFrame : public QFrame, public Ui::SelectionFrameGUI
{
    Q_OBJECT 

    MyWrdFile *wrd;
    AnyBox* m_box;

    enum { NO, CREATION_DATE, COUNT, TIME_LENGTH, ANNOTATION };
    QStringList m_sessionLst;

    QString tabHdrRemark;
    QString tabHdrSession;
    QString tabHdrTitle;
    QString tabHdrKeyword;
    QString tabHdrDate;
    QString tabHdrPrint;
    QString tabHdrCategory;
    QString modifySymbol;

    QString remark;    
    QString session;
    QString title;
    QString keyword;
    QString date;
    QString print;
    QString category;

    QString fromLabel;
    QString beforeLabel;

    bool firstStep;

    MyTmpFile::tasks steps;

    QSet<QString> keyPresentList;
    QSet<QString> keyAbsentList;

    QStringList whichPossibleValue;

    QCompleter *wordCompleter;

    int stageNumber();

    quint32 remarkFound;

    void setValue();
    QString makeWordRequest();
    QString makeDateRequest();    

    bool eventFilter(QObject *, QEvent *);
    void changeEvent(QEvent *event);

    void retranslateCategory();
    void setTabTitles();
    void setWhichPossibleValue();
    void retranslateDateGroupBoxTitle();

    bool setHeaderRemark();
    bool setHeaderCategory();
    bool setHeaderKeyword();
    bool setHeaderDate();
    bool setHeaderSession();
    bool setHeaderPrint();
    bool setHeaderTitle();

    QString remarkToResemble(const QString &);

protected:
     void keyPressEvent(QKeyEvent*);
     bool event(QEvent*);

private slots:
    //Tab Remark
    void setModeRemarkAddButton(QString);
    void setModeRemarkRemoveButton();
    void setModeRemarkClearButton();
    void pressRemarkRemoveButton();
    void pressRemarkClearButton();
    void pressRemarkAddButton();
    //Tab Session
    void setModeSessionClearButton();
    void pressSessionClearButton();      
    void setModeSessionClearAnnFilterButton();
    void pressSessionClearAnnFilterButton();
    void applySessionAnnFilter(QString);
    void setSessionLst();    
    //Tab Title&Author
    void setModeTitleAddButton(QString);
    void setModeTitleRemoveButton();
    void setModeTitleClearButton();
    void pressTitleRemoveButton();
    void pressTitleClearButton();
    void pressTitleAddButton();
    //Tab keyword
    void setModeWordPresentAndAbsentButton(QString);
    void setModeWordPresentClearButton();
    void setModeWordPresentRemoveButton();
    void setModeWordAbsentClearButton();
    void setModeWordAbsentRemoveButton();
    void setModeWordClearButton();
    void setModeWordRemoveButton();
    void setModeWordAddButton();
    void pressWordPresentButton();
    void pressWordAbsentButton();
    void pressWordPresentClearButton();
    void pressWordPresentRemoveButton();
    void pressWordAbsentClearButton();
    void pressWordAbsentRemoveButton();
    void pressWordClearButton();
    void pressWordRemoveButton();
    void pressWordAddButton();
    //Tab date
    void setTitleFromGroupBox();
    void setTitleFromGroupBox(bool);
    void setTitleBeforeGroupBox();
    void setTitleBeforeGroupBox(bool);
    void setModeDateClearButton();
    void setModeDateRemoveButton();
    void setModeDateAddButton();
    void pressDateClearButton();
    void pressDateRemoveButton();
    void pressDateAddButton();
    //
    void setModeStartButton();
    void setModeStartButton(int);
    //

    void pressStart();

public:    
    SelectionFrame(const QString &, AnyBox*, SearchDialog*, QFrame*);
    ~SelectionFrame();

    quint32 getRemarkFoundCount();

    MyTmpFile::tasks getSteps();

signals:
    void searchOver();

public slots:

};

#endif // SELECTIONFRAME_H
