#include "selector.h"
#include "global.h"

#include <QRegExp>
#include <QSet>

Selector::Selector(QString r, QString c, QString k, QString d, QString s, QString p,
                   QString t, Category cat, QString df)
{        
    dateFormat = df;

    int l;
    l = SIGN_INV.length();

    // Remark
    remark = r.replace(" ","");    
    if (remark.left(l) == SIGN_INV) {
        iRemark = true;
        remark.remove(0,l);
    } else {
        iRemark = false;
    }
    remarkParts = remark.split(",");
    remarkParts.removeAll("");

    // Category
    category = c.replace(" ","");    
    if (category.left(l) == SIGN_INV) {
        iCategory = true;
        category.remove(0,l);
    } else {
        iCategory = false;
    }
    categoryParts = category.split(",");

    // Keyword
    keyword = k.replace(" ","");    
    if (keyword.left(l) == SIGN_INV) {
        iKeyword = true;
        keyword.remove(0,l);
    } else {
        iKeyword = false;
    }
    keywordParts = keyword.split(",");
    keywordParts.removeAll("");

    // Date
    date = d.replace(" ","");    
    if (date.left(l) == SIGN_INV) {
        iDate = true;
        date.remove(0,l);
    } else {
        iDate = false;
    }
    dateParts = date.split(",");
    dateParts.removeAll("");

    QDate a,b;
    dt_template z;
    QStringList q;
    cmpDateParts.clear();
    foreach(QString s, dateParts){
        q = s.split("-");
        switch (q.count()){
        case 1:
            a = QDate::fromString(q.at(0),dateFormat);
            if (a.isValid()) {
                z.date_A = a;
                z.date_B = a;
                z.mode = AT;
                cmpDateParts.append(z);
            }
            break;
        case 2:
            a = QDate::fromString(q.at(0),dateFormat);
            b = QDate::fromString(q.at(1),dateFormat);
            if (a.isValid() && b.isValid()){
                z.date_A = a;
                z.date_B = b;
                z.mode = RANGE;
                cmpDateParts.append(z);
                break;
            }
            if (!a.isValid() && b.isValid()){
                z.date_A = b;
                z.date_B = b;
                z.mode = BEFORE;
                cmpDateParts.append(z);
                break;
            }
            if (a.isValid() && !b.isValid()){
                z.date_A = a;
                z.date_B = a;
                z.mode = FROM;
                cmpDateParts.append(z);
                break;
            }
        default:;
        }
    }

    // Session
    session = s.replace(" ","");    
    if (session.left(l) == SIGN_INV) {
        iSession = true;
        session.remove(0,l);
    } else {
        iSession = false;
    }
    sessionParts = session.split(",");
    sessionParts.removeAll("");

    // Print
    print = p.replace(" ","");    
    if (print.left(l) == SIGN_INV) {
        iPrint = true;
        print.remove(0,l);
    } else {
        iPrint = false;
    }
    printParts = print.split(",");
    printParts.removeAll("");

    // Title
    title = t;
    if (title.left(l) == SIGN_INV) {
        iTitle = true;
        title.remove(0,l);
    } else {
        iTitle = false;
    }
    titleParts = title.split(",");
    titleParts.removeAll("");

    {
        QStringList a;
        foreach(QString tmp, titleParts){
            a.append(tmp.simplified());
        }
        titleParts = a;
    }

    QStringList subCat;

    subCat = cat.listSubCategoryValues_A();
    aa[subCat.at(0)] =   1;
    aa[subCat.at(1)] =   2;
    aa[subCat.at(2)] =   4;
    aa[subCat.at(3)] =   8;
    aa[subCat.at(4)] =  16;
    aa[subCat.at(5)] =  32;
    aa[subCat.at(6)] =  64;
    aa[subCat.at(7)] = 128;
    aa[subCat.at(8)] = 256;

    subCat = cat.listSubCategoryValues_B();
    aa[subCat.at(0)] =   1;
    aa[subCat.at(1)] =   2;
    aa[subCat.at(2)] =   4;
    aa[subCat.at(3)] =   8;
    aa[subCat.at(4)] =  16;
    aa[subCat.at(5)] =  32;
    aa[subCat.at(6)] =  64;
    aa[subCat.at(7)] = 128;
    aa[subCat.at(8)] = 256;

    QSet<QString> dropCaps;
    foreach(QString str, subCat){
        dropCaps << str.left(1);
    }
    regExpDropCaps = "^(" + QStringList(dropCaps.toList()).join("|") + ").+";

    subCat = cat.listSubCategoryValues_C();
    bb[subCat.at(0)] = 0;
    bb[subCat.at(1)] = 1;

    subCat = cat.listSubCategoryValues_D();
    cc[subCat.at(0)] = 0;
    cc[subCat.at(1)] = 1;
    cc[subCat.at(2)] = 2;
    cc[subCat.at(3)] = 3;

    subCat = cat.listSubCategoryValues_E();
    dd[subCat.at(0)] = 0;
    dd[subCat.at(1)] = 1;
    dd[subCat.at(2)] = 2;
    dd[subCat.at(3)] = 3;

    subCat = cat.listSubCategoryValues_F();
    ee[subCat.at(0)] = 0;
    ee[subCat.at(1)] = 1;
    ee[subCat.at(2)] = 2;
    ee[subCat.at(3)] = 3;
    ee[subCat.at(4)] = 4;
    ee[subCat.at(5)] = 5;
    ee[subCat.at(6)] = 6;
    ee[subCat.at(7)] = 7;
    ee[subCat.at(8)] = 8;
    ee[subCat.at(9)] = 9;
    ee[subCat.at(10)] = 10;
    ee[subCat.at(11)] = 11;
    ee[subCat.at(12)] = 12;
    ee[subCat.at(13)] = 13;
    ee[subCat.at(14)] = 14;
    ee[subCat.at(15)] = 15;

    subCat = cat.listSubCategoryValues_G();
    ff[subCat.at(0)] = 0;
    ff[subCat.at(1)] = 1;
}

bool Selector::cmp_remark(QString a)
{   
    int t;    
    if (!remarkParts.isEmpty()){
        t = remarkParts.count();
        foreach (QString r, remarkParts){
            if (iRemark){
                if (a != r) { t--; }
                if (t == 0) { return true; }
            } else {
                if (a == r) { return true; }
            }
        }
    } else { return true; }
    return false;
}

bool Selector::cmp_category(QString a)
{
    if (!categoryParts.isEmpty()){
        bool check;
        check = check_category(a.toUInt());
        if (iCategory){
            if (!check){ return true; }
        } else {
            if (check) { return true; }
        }
    } else { return true; }
    return false;
}

bool Selector::cmp_session(QString a)
{
    int t;
    if (!sessionParts.isEmpty()){
        t = sessionParts.count();
        foreach (QString s, sessionParts){
            if (iSession){
                if (a != s) { t--; }
                if (t == 0) { return true; }
            } else {
                if (a == s) { return true; }
            }
        }
    } else { return true; }
    return false;
}

bool Selector::cmp_title(QString a)
{
    int t;
    if (!titleParts.isEmpty()){
        t = titleParts.count();
        foreach (QString s, titleParts){
            if (iTitle){
                if(a.indexOf(s,0,Qt::CaseInsensitive) == -1) { t--; }
                if (t == 0) { return true; }
            } else {
                if (a.indexOf(s,0,Qt::CaseInsensitive) > -1) { return true; }
            }
        }
    } else { return true; }
    return false;   
}

bool Selector::cmp_date(QString d)
{    
    QDate dt;
    int t;
    bool shortDate;
    shortDate = false;
    if (!cmpDateParts.isEmpty()){
        dt = QDate::fromString(d,dateFormat);
        if (!dt.isValid()) {
            return false;
        }
        t = cmpDateParts.count();
        foreach(dt_template tmp, cmpDateParts){            
            switch(tmp.mode){
            case AT:
                if (iDate){
                    if (dt != tmp.date_A) { t--; }
                    if (t == 0) { return true; }
                } else {
                    if (dt == tmp.date_A) { return true; }
                }
                break;
            case RANGE:;
                if (iDate){
                    if (dt < tmp.date_A || dt > tmp.date_B) { t--; }
                    if (t == 0) { return true; }
                } else {
                    if (dt >= tmp.date_A && dt <=tmp.date_B) { return true; }
                }
                break;
            case BEFORE:
                if (iDate){
                    if (dt > tmp.date_B) { t--; }
                    if (t == 0) { return true; }
                } else {
                    if (dt <= tmp.date_B) { return true; }
                }
                break;
            case FROM:
                if (iDate){
                    if (dt < tmp.date_A) { t--; }
                    if (t == 0) { return true; }
                } else {
                    if (dt >= tmp.date_A) { return true; }
                }
                break;
            default:;
            }
        }
    } else { return true; }
    return false;
}

bool Selector::cmp_print(QString a)
{
    int t;
    if (!printParts.isEmpty()){
        bool ok;
        quint32 b;
        b = a.toUInt(&ok);
        if (ok && b > 0){ a = "1"; } else { a = "0"; }
        t = printParts.count();
        foreach (QString p, printParts){
            if (iPrint){
                if (a != p) { t--; }
                if (t == 0) { return true; }
            } else {
                if (a == p) { return true; }
            }
        }
    } else { return true; }
    return false;
}

bool Selector::cmp_keyword(QString a)
{
    int t;
    if (!keywordParts.isEmpty()){
        t = keywordParts.count();
        QStringList k;
        int c;
        foreach(QString i, keywordParts){
            k = i.split(QRegExp("\\+|\\-"));
            c = k.count();
            int x,y;
            QString ch;
            foreach(QString j, k){
                x = i.indexOf(j);
                if (x > 0){
                    ch = i.mid(x -1 , 1);
                } else {
                    ch = "+";
                }
                y = a.indexOf(j);
                if ((y > -1 && ch == "+") || (y == -1 && ch == "-")){ c--; }
            }
            if (iKeyword){
                if (c > 0) { t--; }
                if (t == 0) { return true; }
            } else {
                if (c == 0) { return true; }
            }
        }
    } else { return 1; }
    return false;
}

bool Selector::check_category(quint32 a)
{

    int add;
    add = 6 - categoryParts.count();
    while (add > 0){
        categoryParts.append("");
        add--;
    }

    QMap<QString,QString> b;

    b["which"]   = categoryParts.at(0);
    b["where"]   = categoryParts.at(1);
    b["daytime"] = categoryParts.at(2);
    b["season"]  = categoryParts.at(3);
    b["picture"] = categoryParts.at(4);
    b["method"]  = categoryParts.at(5);

    quint32 which, whichmain, where, daytime, season, picture, method;

    which     = Category::subCategoryValue_A(a);
    whichmain = Category::subCategoryValue_B(a);
    where     = Category::subCategoryValue_C(a);
    daytime   = Category::subCategoryValue_D(a);
    season    = Category::subCategoryValue_E(a);
    picture   = Category::subCategoryValue_F(a);
    method    = Category::subCategoryValue_G(a);

    if (!b.value("which").isEmpty()){
        quint32 template_present, template_absent, template_presentMajor, template_presentNotMajor;

        template_present = 0;
        template_absent = 0;
        template_presentMajor = 0;
        template_presentNotMajor = 0;

        QList<QString> q, tst;
        tst = b.value("which").split(QRegExp("\\+|\\-"));
        foreach(QString tmp, tst){
            if (aa.contains(tmp)){
                q.append(tmp);
            }
        }

        foreach(QString tmp, q){
            int i;
            i = b.value("which").indexOf(tmp);
            QString ch;
            if (i > 0) {
                ch = b.value("which").mid(i - 1, 1);
            } else {
                ch = "+";
            }

            if (QRegExp(regExpDropCaps).exactMatch(tmp)){
                if (ch == "-"){
                    template_presentNotMajor += aa.value(tmp);
                } else {
                    template_presentMajor += aa.value(tmp);
                }
            } else {
                if (ch == "-"){
                    template_absent += aa.value(tmp);
                } else {
                    template_present += aa.value(tmp);
                }
            }
        }

        quint32 dif_present, dif_absent, dif_presentMajor, dif_presentNotMajor;

        dif_present = (which & template_present) - template_present;
        dif_absent = (which & template_absent);
        dif_presentMajor = (whichmain & template_presentMajor) - template_presentMajor;

        if ((which & template_presentNotMajor) - template_presentNotMajor){
            dif_presentNotMajor = 1;
        } else {            
            dif_presentNotMajor = (whichmain & template_presentNotMajor);
         }

        if (dif_present ||  dif_absent || dif_presentMajor || dif_presentNotMajor){
            return false;
        }
    }

    if (!b.value("where").isEmpty()){
       QList<QString> tst;
       tst = b.value("where").split("|");
       int i;
       i = tst.count();
       foreach(QString tmp, tst){
           if (bb.contains(tmp) && (where == bb.value(tmp))){
               break;
           } else {
               i--;
           }
       }
       if (i == 0) { return false; }
    }

    if (!b.value("daytime").isEmpty()){
        QList<QString> tst;
        tst = b.value("daytime").split("|");
        int i;
        i = tst.count();
        foreach(QString tmp, tst){
            if (cc.contains(tmp) && (daytime == cc.value(tmp))){
                break;
            } else {
                i--;
            }
        }
        if (i == 0) { return false; }
    }

    if (!b.value("season").isEmpty()){
        QList<QString> tst;
        tst = b.value("season").split("|");
        int i;
        i = tst.count();
        foreach(QString tmp, tst){
            if (dd.contains(tmp) && (season == dd.value(tmp))){
                break;
            } else {
                i--;
            }
        }
        if (i == 0) { return false; }
    }

    if (!b.value("picture").isEmpty()){
        QList<QString> tst;
        tst = b.value("picture").split("|");
        int i;
        i = tst.count();
        foreach(QString tmp, tst){
            if (ee.contains(tmp) && (picture == ee.value(tmp))){
                break;
            } else {
                i--;
            }
        }
        if (i == 0) { return false; }
    }

    if (!b.value("method").isEmpty()){
        QList<QString> tst;
        tst = b.value("method").split("|");
        int i;
        i = tst.count();
        foreach(QString tmp, tst){
            if (ff.contains(tmp) && (method == ff.value(tmp))){
                break;
            } else {
                i--;
            }
        }
        if (i == 0) { return false; }
    }
    return true;
}

bool Selector::match(Entry* entry)
{
    bool result = false;

    if ((entry->getField(REMARK) == entry->getField(RESEMBLE)) &&
        cmp_remark(entry->getField(REMARK)) &&
        cmp_category(entry->getField(CATEGORY)) &&
        cmp_session(entry->getField(SESSION)) &&
        cmp_print(entry->getField(PRINT)) &&
        cmp_title(entry->getField(TITLE)) &&
        cmp_keyword(entry->getField(KEYWORD)) &&
        cmp_date(entry->getField(DATEOFCREATION)))
    {
        result = true;
    }

    return result;
}
