#include <QApplication>
#include "mainwindow.h"

#ifdef Q_OS_UNIX
#include <csignal>
#endif

#ifdef Q_OS_UNIX
static int setup_unix_signal_handlers()
{
    struct sigaction term;

    term.sa_handler = MainWindow::termSignalHandler;
    sigemptyset(&term.sa_mask);

    //term.sa_flags |= SA_RESTART;
    term.sa_flags = SA_RESTART;

    if (sigaction(SIGTERM, &term, 0) > 0)
        return 2;

    return 0;
}
#endif

int main(int argc, char *argv[])
{   
    QApplication a(argc, argv);
    a.setStyle("plastique");

    QString args;
    for (int i = 1; i < argc; i++){
        args.append(argv[i]);
        if (i < argc - 1) {
            args.append(" ");
        }
    }

#ifdef Q_OS_UNIX
    setup_unix_signal_handlers();
#endif

    MainWindow w(args);

    w.show();

    return a.exec();
}
